<?

//  ü ϱ
class Cast_info_Builder {

	private $cast_ip;
	private $cast_port;
	private $cast_server_list = null;
	private $cast_obj;

	private function __construct() {		
		$this->cast_obj = new winamp_cast_info();
	}

	public static function Set() {		
		$builder = new self;
		return $builder;
	}

	public function ip($ip) {
		$this->cast_ip = $ip;
		return $this;
	}

	public function port($port) {
		$this->cast_port = $port;
		return $this;
	}

	public function multi_server(array $ip){
		
		$this->cast_server_list = $ip;
		return $this;
	}

	public function builder() {
		
		//  Ʈ ɹ ̸ 
		if($this->cast_server_list == null){

			// ϼ	 - ּҼ
			$this->cast_obj->Cast_Url_Set($this->cast_ip,$this->cast_port);
		
		}else{

			// Ƽ - ּҼ
			$this->cast_obj->SetMulti_Server($this->cast_server_list);
		
		}
		return $this->cast_obj;
	}

}



# winamp  Ŭ  (2009.3.29)# 
class winamp_cast_info { 

	# ּ
	private $real_ip = null;
	private $real_port = null;

	#  Ÿ ӽ 
	private $tmp_data = null;
	
	#   迭(2迭)
	public $info = array();
	
	# Ƽ ּ(2迭 :ip,port)
	private $multi_server_addr = array();

	###  ###
	function __construct () {
		
	}
	
	### ּҼ - ϼ ###
	public function Cast_Url_Set($ip,$port = null){
		
			if($port == null){  
			
				// ּ ˾Ƴ
				$this->Real_Cast_ip($ip);

			}else{

				$this->real_ip = $ip;
				$this->real_port = $port;
		
			}
		
	 }
	
	 ###  ϱ ###
	 public function Cast_info_Get(){
		
		$info_tmp_AverageListenTime = array();

		$multi_server_count = count($this->multi_server_addr);
		
		// Ƽ ּ  Ǿ
		if($multi_server_count > 1){
			
			for($i=0;$i <=$multi_server_count-1;$i++){
		
				$this->Read_Cast_info_Data($this->multi_server_addr[$i]["ip"],$this->multi_server_addr[$i]["port"]);
				
				if($i > 0){
					//  ó - û κи ó
					$this->set_info_Data(1);
				}else if($i == 0){
					//  ó - ó
					$this->set_info_Data(0);
				}

				$info_tmp_listeners += $this->info["Listeners"]; 
				$info_tmp_MaxListeners += $this->info["MaxListeners"];
				$info_tmp_ListenersPeak += $this->info["ListenersPeak"];
				//echo $this->info["AverageListenTime"],"<br>";
				$info_tmp_AverageListenTime[] = $this->info["AverageListenTime"];

			}

			$this->info["Listeners"] = $info_tmp_listeners;
			$this->info["MaxListeners"] = $info_tmp_MaxListeners;
			$this->info["ListenersPeak"] = $info_tmp_ListenersPeak;
			
			// ûð ϱ
			$tmp = $this->SumOfTime($info_tmp_AverageListenTime);
			$second = $this->convert_second($tmp["hour"],$tmp["minute"],$tmp["second"]);
			$this->info["AverageListenTime"] = $this->counter_time($second);
			
		
		// Ƽ ּ  
		}else{
		
			//  Ÿ ܾ
			$this->Read_Cast_info_Data($this->real_ip,$this->real_port);
		
			//  ó
			$this->set_info_Data(0);

		}

	 }

	 ###  xml   ###
	 public function print_xml_data(){ 
		
		header('Content-type: application/xml');
		
		// PHP(5.1.2 ̻ ) ⺻ ϴ XmlWriter Ŭ̿
		$xml = new XmlWriter();
		$xml->openMemory();
		$xml->startDocument('1.0', 'UTF-8');	
		$xml->startElement('cast_info');
		
		$cast_info = array("Title","Genre","URL","AIM","IRC","CurrentSong","Kbps","Listeners","MaxListeners","ListenersPeak","AverageListenTime");
		
		for($i=0;$i <=count($cast_info)-1;$i++){
			
			if($this->info[$cast_info[$i]]){

				$xml->startElement($cast_info[$i]);
				$xml->writeCData(iconv("CP949","UTF-8",$this->info[$cast_info[$i]]));
				$xml->endElement();

			}else{

				$xml->startElement($cast_info[$i]);
				$xml->writeCData(iconv("CP949","UTF-8",""));
				$xml->endElement();

			}

		}

		$xml->endElement();
		echo $xml->outputMemory(true);

	 }
	
	### ּҼ - Ƽ ּ  ###
	public function SetMulti_Server(array $ip){
		
		$ip_count = count($ip);

		if($ip_count > 0){ 
			
			$ip_list = array();

			for($i=0;$i<=$ip_count-1;$i++){
	
				$tmp_url = $ip[$i];

				//   ǿƮ 
				if(preg_match("/([\.a-zA-Z0-9]{1,}):([0-9]{1,})/i", $tmp_url , $matches)){

					$ip_list[] = array("ip"=>$matches[1],"port"=>$matches[2]);

				}else{
					throw new Exception($tmp_url . "() ּĿ ʽϴ"); 
				}

				$tmp_url = "";

			}

		
	

			$this->multi_server_addr = $ip_list;

		}else{
			throw new Exception("Ƽ ƴմϴ"); 
		}


	}




	###  ###
	private function wsocket($ip,$port,$header){ 

		$sock = socket_create(AF_INET, SOCK_STREAM,getprotobyname('tcp'));
		$connected = @socket_connect($sock,$ip,$port);

		if ($connected) { 

			socket_write($sock, $header, strlen ($header));

			while($buf = socket_read($sock ,1024)){ $data .= $buf; }
			socket_close($sock); 
			return $data;

		}else{
	
			echo "ӿ-",socket_strerror(socket_last_error());

		}
			
			
		socket_close($sock); 

	}



	### ּ ˾Ƴ ###
	private function Real_Cast_ip($cast_url){ 
		
		//  
		$header = "GET / HTTP/1.0\r\n"; 
		$header .= "Host: " . $cast_url . "\r\n";
		$header .= "User-Agent: WinampMPEG/5.541\r\n";  
		$header .= "Accept: */*\r\n";  
		$header .= "Connection: close\r\n\r\n";  

		$data = $this->wsocket($cast_url,80,$header);
			
			if(preg_match("/http:\/\/([\.a-zA-Z0-9]{1,}):([0-9]{1,})/i", $data, $matches)){

				$this->real_ip = $matches[1];
				$this->real_port = $matches[2];

			}

	}


	###  Ÿ ܾ ###
    private function Read_Cast_info_Data($ip,$port){ 
		
		//  
		$header = "GET /index.html HTTP/1.0\r\n"; 
		//$header .= "Host: " . $ip . "\r\n";
		$header .= "User-Agent: Mozilla/4.0\r\n";  
		$header .= "Connection: close\r\n\r\n";  
		
		$data = $this->wsocket($ip,$port,$header);
		
		$this->tmp_data = strip_tags($data,"<tr>");

	 }

	
	###  ó ###
    private function set_info_Data($Listen){ 
		
		switch ($Listen) {
			
			case 1:
			
				if(preg_match("/with ([0-9]{1,}) of ([0-9]{1,}) listeners/i", $this->tmp_data, $matches)){
			
					$this->info["Listeners"] = trim($matches[1]);
					$this->info["MaxListeners"] = trim($matches[2]);

				}

				if(preg_match("/Listener Peak: ([0-9]{1,})/i", $this->tmp_data, $matches)){

					$this->info["ListenersPeak"] = trim($matches[1]);
				}

				if(preg_match("/Average Listen Time: ([0-9]{1,}m [0-9]{1,}s|[0-9]{1,}h [0-9]{1,}m [0-9]{1,}s)/i", $this->tmp_data, $matches)){

					$this->info["AverageListenTime"] = trim($matches[1]);
				}

			break;

			case 0:

				$find_key = array("Stream Title:","Stream Genre:","Stream URL:","Stream AIM:","Stream IRC:","Current Song:");
				$info_key = array("Title","Genre","URL","AIM","IRC","CurrentSong");
		
				$key_count = count($find_key);

				for($i=0;$i < $key_count;$i++){
			
					$pattern = "/<tr>" . $find_key[$i] . "(.*?)<\/tr>/i";
			
					if(preg_match($pattern, $this->tmp_data, $matches)){

						$this->info[$info_key[$i]] = trim(urldecode($matches[1]));

					}
		
				}
		
				//echo $this->tmp_data;

				if(preg_match("/([0-9]{1,}) kbps/i", $this->tmp_data, $matches)){

					$this->info["Kbps"] = trim($matches[1] . " kbps");

				}
		
				if(preg_match("/with ([0-9]{1,}) of ([0-9]{1,}) listeners/i", $this->tmp_data, $matches)){
			
					$this->info["Listeners"] = trim($matches[1]);
					$this->info["MaxListeners"] = trim($matches[2]);

				}

				if(preg_match("/Listener Peak: ([0-9]{1,})/i", $this->tmp_data, $matches)){

					$this->info["ListenersPeak"] = trim($matches[1]);
				}

				if(preg_match("/Average Listen Time: ([0-9]{1,}m [0-9]{1,}s)/i", $this->tmp_data, $matches)){

					$this->info["AverageListenTime"] = trim($matches[1]);
				}

			break;


		}

	}

	
	### ûð հ - Ƽۼ ûð  ###
	private function SumOfTime(array $data){
	
		$tmp = array("hour"=>0,"minute"=>0,"second"=>0);

		for($i=0;$i<=count($data)-1;$i++){
		
			if(preg_match("/([0-9]{1,}m [0-9]{1,}s|[0-9]{1,}h [0-9]{1,}m [0-9]{1,}s)/i", $data[$i], $matches1)){
			
				//echo trim($matches1[1]);
				if(preg_match("/([0-9]{1,})h/i",trim($matches1[1]),$h)){ $tmp["hour"] += trim($h[1]); }

				if(preg_match("/([0-9]{1,})m/i",trim($matches1[1]),$m)){ $tmp["minute"] += trim($m[1]); }

				if(preg_match("/([0-9]{1,})s/i",trim($matches1[1]),$s)){ $tmp["second"] += trim($s[1]); }
				
			}

		}
		return $tmp;
	}


	### ð ʷ ȯ - Ƽۼ ûð  ###
	private function convert_second($hour,$minute,$second){
	
		$tmp_second += $second;

		if($hour){ 

			// 1ð 3600
			$tmp_second += $hour * 3600; 
		}
	
		if($minute){ 
		
			// 1 60
			$tmp_second += $minute * 60;
	
		}
	
		return $tmp_second;
	}

	### ð  - Ƽۼ ûð  ###
	private function counter_time($tmp_second){

		for($i=0;$i <= $tmp_second-1;$i++){

			$second += 1;
		
			// 60
			if($second == 60){ $second = 0; $minute += 1;
				// 1ð
				if($minute == 60){ $minute = 0; $hour +=1;  
					// 24ð
					if($hour == 24){ $hour = 0; $day += 1; }
				}
			}

		}
		
		if($day >0){ $time .= $day ." "; }
		if($hour >0){ $time .= $hour ."ð "; }
		if($minute >0){ $time .= $minute ." "; }
		if($second >0){ $time .= $second .""; }

		return $time;

	}



}

?>